
#include "bits/bitlex.h"
#include "bits/printbitset.h"

#include "fxttypes.h"
#include "fxtiomanip.h"
#include "bits/printbin.h"
#include "bits/bitsperlong.h"

//#include "bits/graycode.h"

#include "demo/nextarg.h"


//% Generating binary words in subset-lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "n-bit binary words");
    ulong m = 1UL<<n;
    bool bq = 0;
    NXARG(bq, "Whether to also print backwards list");
    const ulong rq = n;

#ifndef TIMING
    ulong x = 1UL<<(n-1);  // first subset
    ulong ct = 0;
    do
    {
        ++ct;
        cout << setw(2) << ct << ":  ";
        print_bin_nn("", x, n);
        cout << "  = " << setw(2) << x;
        print_bit_set("  ", x, rq);
        cout << endl;
    }
    while ( (x=next_lexrev(x)) );


    cout << endl;

    if ( bq )
    {
//        cout << " ... and backward (fixed point marked with '*'):" << endl;
        ct = 1;
        while ( (x = prev_lexrev(x)) < m )
        {
            cout << setw(2) << ct << ":  ";
            print_bin_nn("", x, n);
            cout << "  = " << setw(2) << x;
            print_bit_set("  ", x, rq);

//            print_bin_nn("  ", negidx2lexrev(ct), n+1);  // == x
//            ulong z = x ^ next_lexrev(x);
//            print_bin_nn("  ", z, n+1);
//            if ( is_lexrev_fixed_point(x) )  cout << " *";
            ++ct;
            cout << endl;
        }
    }
#else

//    ulong x = 0;  while ( (x=prev_lexrev(x)) )  { ; }
    ulong x = 1UL<<(n-1);
    while ( (x=next_lexrev(x)) )  { ; }
//    while ( x-- )  { ; }

#endif

    return  0;
}
// -------------------------

/*
Timing:
% time ./bin 31
./bin 31  10.57s user 0.06s system 100% cpu 10.632 total
 ==> 2^31/10.57 == 203,167,800 words / sec

Just decrementing:
./bin 31  0.98s user 0.00s system 99% cpu 0.986 total
 ==> 2^31/0.98 == 2,191,309,844 words / sec (1 cycle)
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bitlex-demo.cc"
/// End:

