
#include "comb/setpartition-rgs.h"
// demo-include "comb/setpartition-rgs.cc"

//#include "jjassert.h"
#include "fxtiomanip.h"
#include "fxttypes.h"

#include "demo/nextarg.h"

//% Set partitions as restricted growth strings (RGS).


//#define TIMING // uncomment to disable printing


int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "Partition set of n elements");
    bool xdr = true;
    NXARG(xdr, "Change direction in recursion ==> minimal-change order");
    int dr0 = +1;
    NXARG(dr0, "Starting direction in recursion (+-1)");
    dr0 = ( (dr0>0) ? +1 : -1 );
    ulong maxct = 0;
    NXARG(maxct, "Stop after maxct partitions (0: never stop)");

    set_partition_rgs P(n, xdr, dr0);

    ulong ct = 0;
    do
    {
        ++ct;
#ifndef TIMING
        cout << setw(3) << ct << ":  ";
        P.print();
        cout << endl;
        if ( maxct && (ct>maxct) )  break;
#endif // TIMING
    }
    while ( P.next() );

    cout << " ct = " << ct << endl;

    return 0;
}
// -------------------------

/*
Timing:
% time ./bin 14
arg 1: 14 == n  [Partition set of n elements]  default=5
arg 2: 1 == xdr  [Change direction in recursion ==> minimal-change order]  default=1
arg 3: 1 == dr0  [Starting direction in recursion (+-1)]  default=1
arg 4: 0 == maxct  [Stop after maxct partitions (0: never stop)]  default=0
 ct = 190899322

// iterative next():
./bin 14  1.35s user 0.02s system 99% cpu 1.371 total
 ==> 141,406,905  setpart/sec

// recursive next():
./bin 14  2.43s user 0.02s system 99% cpu 2.454 total
 ==> 78,559,391 setpart/sec
*/


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/setpartition-rgs-demo.cc"
/// End:

