################## FXT files.mk ##########################

#-------------------------------------

TMPDIR=/tmp
TMP1=$(TMPDIR)/tmp1
TMP2=$(TMPDIR)/tmp2
TMP3=$(TMPDIR)/tmp3

#-------------------------------------

FXTLIB=libfxt.a
LIBS = $(FXTLIB) $(PPLIBS)

SCRIPTDIR=./scripts

FXTIDIR=./src

NONSRCDIRS= \
./data \
./demo \
./doc \
./include \
./scripts \
./simplfft \
./test \

SHFXTSRCDIRS= \
./aux0 \
./aux1 \
./aux2 \
./bits \
./bpol \
./bmat \
./chirpzt \
./comb \
./graph \
./convolution \
./correlation \
./dctdst \
./ds \
./fft \
./fht \
./haar \
./matrix \
./mod \
./mult \
./ntt \
./perm \
./realfft \
./sort \
./walsh \
./wavelet \

FXTSRCDIRS=$(shell find src -mindepth 1 -maxdepth 1 -type d)
FXTHDRS=$(shell find src -maxdepth 2 -name \[a-zA-Z]\*.h)

#-------------------------------------


AUXOBJS= \
src/bits/revbin-upd.o \
src/bits/revbin-tab.o \
src/bits/hilbert.o \
src/bits/tinyfactors.o \
src/bits/printbin.o \
src/bits/printbindiff.o \
src/bits/printbitset.o \
src/bits/crc32.o \
src/bits/crc64.o \
\
src/bpol/bitpol-print.o \
src/bpol/bitpol2lhca.o \
src/bpol/bitpol-order.o \
\
src/bpol/primpoly-rand.o \
src/bpol/primpoly-lowbit.o \
src/bpol/primpoly-minweight.o \
src/bpol/normal-irredpoly.o \
src/bpol/normal-primpoly.o \
src/bpol/lhcarule-minweight.o \
\
src/bpol/normal-mult.o \
src/bpol/normal-solvequadratic.o \
src/bpol/bitpol-squarefree.o \
src/bpol/bitpol-normal.o \
src/bpol/numof-bitpol.o \
src/bpol/berlekamp.o \
src/bpol/bitpol-factor.o \
src/bpol/bitpolmod-solvequadratic.o \
src/bpol/gf2n.o \
src/bpol/gf2n-trace.o \
src/bpol/gf2n-solvequadratic.o \
src/bpol/gf2n-minpoly.o \
src/bpol/gf2n-order.o \
\
src/bmat/bitmatmult.o \
src/bmat/bitmatinverse.o \
src/bmat/bitmatnullspace.o \
src/bmat/bitmathessenberg.o \
src/bmat/bitmatcharpoly.o \
src/bmat/bitmatcompanion.o \
src/bmat/bitmatkronecker.o \
src/bmat/bitmatprint.o \
\
src/aux0/rand.o \
src/aux0/aux0double.o \
src/aux0/aux0print.o \
src/aux0/jjassert.o \
src/aux0/version.o \
src/aux0/binomial.o \
\
src/aux1/bytescan.o \
src/aux1/resample.o \
src/aux1/str2ulong.o \
src/aux1/symmetry.o \
src/aux1/aux1double.o \
src/aux1/auxprint.o \
src/aux1/trigtable.o \
\
src/aux2/array2d.o \
src/sort/sortcomplex.o \
src/sort/radixsort.o \
src/ds/bitarray.o \

#aux0/sincos.o \
#perm/permvisit.o \
#comb/paren.o \

PERMOBJS= \
src/perm/zip.o \
src/perm/radixpermute.o \
src/perm/permq.o \
src/perm/printcycles.o \
src/perm/perminvert.o \
src/perm/permcompose.o \
src/perm/cycles.o \


COMBOBJS= \
src/comb/fact2perm.o \
src/comb/fact2num.o \
src/comb/fact2perm-alt.o \
src/comb/fact2cyclic.o \
src/comb/printperm.o \
\
src/comb/catalan.o \
src/comb/partition.o \
src/comb/partition-rec.o \
src/comb/setpartition.o \
src/comb/setpartition-rgs.o \
src/comb/rgs-maxincr.o \
src/comb/rgs-fincr.o \
src/comb/rgs-binomial.o \
src/comb/combination-minchange.o \
src/comb/combination-altminchange.o \
src/comb/combination-rec.o \
src/comb/delta2gray.o \
src/comb/monotonicgray.o \
src/comb/acgray.o \
src/comb/testgray.o \
src/comb/printgray.o \
src/comb/stringsubst.o \
src/comb/numofnecklaces.o \
src/comb/all-compositions-minchange.o \
src/comb/composition-rank.o \
src/comb/ksubset-near-perfect.o \
src/comb/ksubset-rec.o \
src/comb/printset.o \
\
src/comb/rgs-kincr.o \
\
src/comb/printmixedradix.o \
src/comb/mixedradix2num.o \
\
src/graph/digraph.o \
src/graph/digraphpaths.o \
src/graph/digraphpaths-search.o \
src/graph/digraphpaths-condsearch.o \
src/graph/digraphpaths-trylucky.o \
src/graph/printpath.o \
src/graph/digraphcomplete.o \
src/graph/digraphdebruijn.o \
src/graph/digraphgray.o \
src/graph/digraphparengray.o \
src/graph/digraphfibrepgray.o \
src/graph/digraphmtl.o \
src/graph/digraphlyndongray.o \
src/graph/lyndoncmp.o \


FFTOBJS= \
src/fft/fftdit2.o \
src/fft/fftdif2.o \
src/fft/fftdit4l.o \
src/fft/fftdif4l.o \
src/fft/fftdit4.o \
src/fft/cfftdit4.o \
src/fft/fftdif4.o \
src/fft/cfftdif4.o \
src/fft/fft8ditcore.o \
src/fft/fft8difcore.o \
src/fft/fft9.o \
src/fft/fftsplitradix.o \
src/fft/cfftsplitradix.o \
src/fft/fhtfft.o \
src/fft/fhtcfft.o \
src/fft/fftspect.o \
src/fft/fouriershift.o \
src/fft/skipfft.o \
src/fft/twodimfft.o \
src/fft/ndimfft.o \
src/fft/gfft.o \
src/fft/cfftwrap.o \
src/fft/slowft.o \
src/fft/recfft2.o \
src/fft/weightedfft.o \
src/fft/columnffts.o \
src/fft/rowffts.o \
src/fft/rowcnvls.o \
src/fft/matrixfft.o \


CONVOBJS= \
src/convolution/fftcnvl.o \
src/convolution/fftcnvla.o \
src/convolution/fftcocnvl.o \
src/convolution/fhtcnvlcore.o \
src/convolution/cfhtcnvlcore.o \
src/convolution/fhtcnvlacore.o \
src/convolution/cfhtcnvlacore.o \
src/convolution/fhtcnvl.o \
src/convolution/cfhtcnvl.o \
src/convolution/fhtcnvla.o \
src/convolution/cfhtcnvla.o \
src/convolution/fhtloccnvl.o \
src/convolution/fhtloccnvla.o \
src/convolution/fhtnegacnvl.o \
src/convolution/twodimfhtcnvl.o \
src/convolution/slowcocnvl.o \
src/convolution/weightedconv.o \
src/convolution/matrixfftcnvl.o \
src/convolution/matrixfftcnvla.o \
src/convolution/matrixfftcocnvla.o \

CORROBJS= \
src/correlation/fftcocorr.o \
src/correlation/fftcorr.o \
src/correlation/fhtcorr.o \
src/correlation/slowcocorr.o \


REALFFTOBJS= \
src/realfft/realfftbyfht.o \
src/realfft/realfftwrap.o \
src/realfft/realffteasyord.o \
src/realfft/realfftsplitradix.o \
src/realfft/skiprealfft.o \

OTHERFFTOBJS= \
src/chirpzt/fftarblen.o \
src/chirpzt/fftfract.o \
src/chirpzt/makechirp.o \
src/chirpzt/slowfracft.o \
src/chirpzt/slowzt.o \

FHTOBJS= \
src/fht/fhtdit2.o \
src/fht/fhtdif2.o \
src/fht/fhtdit.o \
src/fht/fhtdif.o \
src/fht/cfhtdit.o \
src/fht/cfhtdif.o \
src/fht/fht0.o \
src/fht/cfht0.o \
src/fht/fhttable.o \
src/fht/fhtspect.o \
src/fht/skipfht.o \
src/fht/twodimfht.o \
src/fht/slowht.o \
src/fht/recfht2.o \

DCTDSTOBJS= \
src/dctdst/cosrot.o \
src/dctdst/dcth.o \
src/dctdst/dct4.o \
src/dctdst/dct.o \
src/dctdst/dctzapata.o \
src/dctdst/dsth.o \
src/dctdst/dst.o \

WALSHOBJS= \
src/walsh/walsheigen.o \
src/walsh/slant.o \

HAAROBJS= \
src/haar/haari2i.o \

WAVELETOBJS= \
src/wavelet/wavelet.o \
src/wavelet/invwavelet.o \
src/wavelet/waveletfilter.o \
src/wavelet/harmonicwavelet.o \

FXTMULTOBJS = \
src/mult/auxil.o \
src/mult/workspace.o \
src/mult/carry.o \
src/mult/fxtmult.o \
src/mult/fxtsquare.o \
src/mult/fxtmultiply.o \
src/mult/diskaux.o \
src/mult/diskaux2.o \
src/mult/diskrowpass.o \
src/mult/diskcolpass.o \
src/mult/diskcnvla.o \
src/mult/disksquare.o \
src/mult/diskmultiply.o \

MODOBJS= \
src/mod/mod.o \
src/mod/modinit.o \
src/mod/modinfo.o \
src/mod/maxorder.o \
src/mod/primes.o \
src/mod/perfpow.o \
src/mod/eratosthenes.o \
src/mod/order.o \
src/mod/factor.o \
src/mod/factormake.o \
src/mod/cyclic.o \
src/mod/chinese.o \
src/mod/quadresidue.o \
src/mod/sqrtmod.o \
src/mod/kronecker.o \
src/mod/rabinmiller.o \
src/mod/euler-phi.o \
src/mod/mersenne-exponents.o \
src/mod/mersenne-factors.o \
src/mod/mersenne-generators.o \
src/mod/testnum.o \
src/mod/chebyshev1.o \
src/mod/chebyshev2.o \

NTTOBJS= \
src/ntt/nttdit2.o \
src/ntt/nttdif2.o \
src/ntt/nttdif2nc.o \
src/ntt/nttdit4.o \
src/ntt/nttdif4.o \
src/ntt/nttlearn.o \
src/ntt/nttcnvl.o \
src/ntt/slownttcnvl.o \
src/ntt/slowntt.o \

#
OBJS =
OBJS += $(AUXOBJS)
OBJS += $(COMBOBJS)
OBJS += $(PERMOBJS)
OBJS += $(FFTOBJS)
OBJS += $(REALFFTOBJS)
OBJS += $(FHTOBJS)
OBJS += $(OTHERFFTOBJS)
#OBJS += $(MATRIXOBJS)
OBJS += $(DCTDSTOBJS)
OBJS += $(CONVOBJS)
OBJS += $(CORROBJS)
OBJS += $(WALSHOBJS)
OBJS += $(HAAROBJS)
OBJS += $(WAVELETOBJS)
OBJS += $(WEIGHTEDOBJS)
OBJS += $(FXTMULTOBJS)
OBJS += $(MODOBJS)
OBJS += $(NTTOBJS)


#
SRC=$(OBJS:.o=.cc)

#-------------------------------------

################## end FXT files.mk ##########################
