
#include "bits/bitrotate.h"
#include "bits/parity.h"

#include "bmat/bitmat.h"

#include "fxttypes.h"  // ulong
//#include "bits/printbin.h"
//#include "fxtiomanip.h"


ulong
normal_mult(ulong a, ulong b, const ulong *M, ulong n)
// Multiply two elements (a and b in GF(2^n))
//  in normal basis representation.
// The multiplication matrix has to be supplied in M.
{
    ulong p = 0;
//    cout << endl; cout << "+++++++++++++++++++" << endl;
    for (ulong k=0; k<n; ++k)
    {
        ulong v = bitmat_mult_Mv(M, n, b);
//        print_bin("   a=", a, n); print_bin("   b=", b, n);
//        print_bin("   M*b=v=", v, n);
        v = parity( v & a );  // dot product
//        print_bin("  a.v =", v, n);
//        cout << "p(v)=" << v << endl;
//        p <<= 1; p ^= v;
        p ^= ( v << k );
        a = bit_rotate_right(a, 1, n);
        b = bit_rotate_right(b, 1, n);
//        cout << endl;
    }
//    print_bin("   p====", p, n);
//    cout << endl;
    return  p;
}
// -------------------------
